"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
/**
 * Birbable entity used to run a sequence of Procedures
 * @abstract
 */
var Pipeline = /** @class */ (function (_super) {
    __extends(Pipeline, _super);
    /**
     * @param options Options to build the new Pipeline
     * @param onFinish Callback executed when the pipeline finishes. Recieves the context as an argument
     * @param onFail Callback executed when a step fails
     */
    function Pipeline(options, onFinish) {
        var _this = _super.call(this, options) || this;
        /**
         * A property used to assert the type of the Birbable
         * @readonly
         */
        _this.__type = 'PIPELINE';
        _this.steps = new Map();
        _this.onFinish = onFinish;
        _this.addStep = _this.addStep.bind(_this);
        _this.execute = _this.execute.bind(_this);
        _this.runPipeline = _this.runPipeline.bind(_this);
        return _this;
    }
    /**
     * Adds a step to the pipeline
     * @param procedure The next procedure to execute
     */
    Pipeline.prototype.addStep = function (procedure) {
        this.steps.set(procedure.constructor.name, procedure);
        return this;
    };
    ;
    Pipeline.prototype.runPipeline = function (executionList, context, descriptable) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, executionList_1, birbable;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _i = 0, executionList_1 = executionList;
                        _a.label = 1;
                    case 1:
                        if (!(_i < executionList_1.length)) return [3 /*break*/, 4];
                        birbable = executionList_1[_i];
                        return [4 /*yield*/, birbable.execute(context, descriptable)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4:
                        if (this.onFinish !== undefined)
                            this.onFinish(context);
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    /**
     * When working with Pipeline's execute method, prefer to pass
     * the context type that you are working with so it is possible to
     * assert the type that you're working with
     */
    Pipeline.prototype.execute = function (context, descriptable) {
        return __awaiter(this, void 0, void 0, function () {
            var executionList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        executionList = [];
                        this.steps.forEach(function (birbable) {
                            executionList.push(birbable);
                        });
                        return [4 /*yield*/, this.runPipeline(executionList, context, descriptable)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return Pipeline;
}(types_1.BirbsRunnable));
exports.Pipeline = Pipeline;
