"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * The base class that a context uses to trigger events.
 * @abstract
 */
var BirbsRunnable = /** @class */ (function () {
    function BirbsRunnable(options) {
        if (options === void 0) { options = { lifetime: 'SINGLE' }; }
        this.__lifetime = options.lifetime;
        if (options.group !== undefined) {
            this.__group = options.group;
        }
    }
    Object.defineProperty(BirbsRunnable.prototype, "lifetime", {
        /**
         * The lifespan of the Birbable Entity
         * can be either 'SINGLE' or 'DURABLE'
         */
        get: function () {
            return this.__lifetime;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BirbsRunnable.prototype, "group", {
        /**
         * The Birbable group of the procedure or pipeline.
         * Only a single procedure of a group may be executed at a time, others of the
         * same group will be discarded when one is emitted.
         */
        get: function () {
            return this.__group;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(BirbsRunnable.prototype, "belongsToGroup", {
        /**
         * @returns a Boolean representing if the entity belongs to any group
         */
        get: function () {
            return this.__group !== undefined;
        },
        enumerable: true,
        configurable: true
    });
    return BirbsRunnable;
}());
exports.BirbsRunnable = BirbsRunnable;
var BroadcastsRecorderEvents;
(function (BroadcastsRecorderEvents) {
    BroadcastsRecorderEvents["WRITE"] = "write";
    BroadcastsRecorderEvents["DUMP"] = "dump";
    BroadcastsRecorderEvents["READ"] = "read";
})(BroadcastsRecorderEvents = exports.BroadcastsRecorderEvents || (exports.BroadcastsRecorderEvents = {}));
;
